## nfs-ganesha 2.7.1

=== src/CMakeLists.txt ===
# NFS Ganesha  Cmake

# Current version as of Fedora 16.  Not tested with earlier.

cmake_minimum_required(VERSION 2.6.3)

message( STATUS "cmake version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" )

if( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )
  if(COMMAND cmake_policy)
      cmake_policy(SET CMP0017 NEW)
  endif(COMMAND cmake_policy)
endif( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

project(nfs-ganesha C CXX)
# Project versioning
set(GANESHA_MAJOR_VERSION 2)
set(GANESHA_MINOR_VERSION 7)

IF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
set(GANESHA_BUILD_RELEASE 1)
ELSE()
set(GANESHA_BUILD_RELEASE 0)
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")

# needs to come after project()
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
	SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Install prefix for common files" FORCE)
	message(STATUS "override default CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "/etc" CACHE PATH "Install prefix for common files")
	SET(SYSSTATEDIR "/var" CACHE PATH "Install prefix for common files")
ELSE()
	message(STATUS "was set CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "Install prefix for common files")
	SET(SYSSTATEDIR "${CMAKE_INSTALL_PREFIX}/var" CACHE PATH "Install prefix for common files")
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
# Patch level is always ".0" for mainline (master).  It is blank for development.
# When starting a stable maintenance branch, this becomes ".N"
# where N is monotonically increasing starting at 1. Remember to include the "." !!
set(GANESHA_PATCH_LEVEL .1)

# Extra version is for naming development/RC.  It is blank in master/stable branches
# so it can be available to end-users to name local variants/versions
# If used, it is always of the form "-whateveryouwant"
set(GANESHA_EXTRA_VERSION )

set(GANESHA_VERSION ${GANESHA_MAJOR_VERSION}.${GANESHA_MINOR_VERSION}${GANESHA_PATCH_LEVEL}${GANESHA_EXTRA_VERSION})
set(GANESHA_BASE_VERSION ${GANESHA_MAJOR_VERSION}.${GANESHA_MINOR_VERSION}${GANESHA_PATCH_LEVEL})

set(VERSION_COMMENT
  "GANESHA file server is 64 bits compliant and supports NFS v3,4.0,4.1 (pNFS) and 9P"
)

# find out which platform we are building on
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(LINUX ON)
  set(UNIX ON)
  # Now detects the Linux's distro
  set(DISTRO "UNKNOWN")
  set(LIBEXECDIR "/usr/libexec")

  EXECUTE_PROCESS(
      COMMAND awk -F=  "/^NAME=/ { print $2 }" /etc/os-release
      OUTPUT_VARIABLE SYS_RELEASE
      ERROR_QUIET
   )
# Red Hat Enterprise Linux versions before 7.0 will be detected as UNKNOWN

  if( ${SYS_RELEASE} MATCHES "Red Hat" )
     message( STATUS "Detected a Linux Red Hat machine" )
     set(DISTRO "RED_HAT")
  elseif( ${SYS_RELEASE} MATCHES "Fedora" )
     message( STATUS "Detected a Linux Fedora machine" )
     set(DISTRO "FEDORA")
  elseif( ${SYS_RELEASE} MATCHES "SLES" )
     message( STATUS "Detected a Linux SLES machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/usr/lib")
  elseif( ${SYS_RELEASE} MATCHES "openSUSE Leap" )
     message( STATUS "Detected a Linux openSUSE Leap machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/usr/lib")
  elseif( ${SYS_RELEASE} MATCHES "openSUSE Tumbleweed" )
     message( STATUS "Detected a Linux openSUSE Tumbleweed machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/usr/lib")
  elseif( (${SYS_RELEASE} MATCHES "Debian GNU/Linux") OR (${SYS_RELEASE} MATCHES "Ubuntu") )
     message( STATUS "Detected a Linux Debian base machine" )
     set(DISTRO "DEBIAN")
     set(LIBEXECDIR "/usr/lib")
  else( ${SYS_RELEASE} MATCHES "Red Hat" )
     message( STATUS "Detected an UNKNOWN Linux machine" )
     set(DISTRO "UNKNOWN")
  endif( ${SYS_RELEASE} MATCHES "Red Hat" )
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(FREEBSD ON)
  set(UNIX ON)
# On FreeBSD libc doesn't directly provide libexecinfo, so we have to find it
  set(USE_EXECINFO ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(WINDOWS ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

# Identify the host we are building on
EXECUTE_PROCESS( COMMAND hostname
  OUTPUT_VARIABLE BUILD_HOST_NAME
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )

find_package(Toolchain REQUIRED)
find_package(Sanitizers)

# Add maintainer mode for (mainly) strict builds
include(${CMAKE_SOURCE_DIR}/cmake/maintainer_mode.cmake)

# For libraries that provide pkg-config files
include(FindPkgConfig)

# For our option system
include(${CMAKE_SOURCE_DIR}/cmake/goption.cmake)

# If we are in a git tree, then this CMakeLists.txt is in "src/" and go .git is in "src/.."
IF( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )
  message( STATUS "Compilation from within a git repository. Using git rev-parse HEAD")
  EXECUTE_PROCESS( COMMAND git rev-parse HEAD
		   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_HEAD_COMMIT)
  EXECUTE_PROCESS( COMMAND git describe --long
                   WORKING_DIRECTORY  ${CMAKE_SOURCE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_DESCRIBE)

ELSE( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )
  message( STATUS "Outside a git repository, use saved data" )
  EXEC_PROGRAM(${CMAKE_SOURCE_DIR}/cmake/githead_from_path.sh ARGS ${CMAKE_SOURCE_DIR}
                OUTPUT_VARIABLE  _GIT_HEAD_COMMIT)

  EXEC_PROGRAM(${CMAKE_SOURCE_DIR}/cmake/gitdesc_from_path.sh ARGS ${CMAKE_SOURCE_DIR}
                OUTPUT_VARIABLE  _GIT_DESCRIBE)

ENDIF( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )

STRING(SUBSTRING ${_GIT_HEAD_COMMIT} 0  7 _GIT_HEAD_COMMIT_ABBREV )

if (FREEBSD)
#default gcc doesn't like using -Wuninitialized without -O on FreeBSD
    set(PLATFORM "FREEBSD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -ggdb")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-optimize-sibling-calls")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/freebsd")
    find_library(LIBDL c)  # libc suffices on freebsd
endif(FREEBSD)

if (LINUX)
    set(PLATFORM "LINUX")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/linux")
    find_library(LIBDL dl)  # module loader
endif(LINUX)

if (MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# Library path name
get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib64 CACHE PATH
		"Specify name of libdir inside install path")
else (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH
		"Specify name of libdir inside install path")
endif (USE_LIB64)

IF(FSAL_DESTINATION)
    set( FSAL_DESTINATION ${FSAL_DESTINATION} )
ELSE()
    set( FSAL_DESTINATION "${LIB_INSTALL_DIR}/ganesha")
ENDIF()

if (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")
  # uname -p is broken on this system.  Try uname -m
  EXECUTE_PROCESS( COMMAND uname -m
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
		   OUTPUT_VARIABLE ARCH)
else (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")
  set(ARCH ${CMAKE_SYSTEM_PROCESSOR})
endif (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")

if (ARCH MATCHES "x86_64")
  # Nothing special to do for x86_64
elseif (ARCH MATCHES "i386")
  # Nothing special to do for i386
elseif (ARCH MATCHES "mips")
  set(SYSTEM_LIBRARIES "-latomic" ${SYSTEM_LIBRARIES})
else()
  message(WARNING "Unhandled architecture ${ARCH}")
endif ()

# FSAL selection
# FSALs which are enabled by default but could be disabled
# during the build
goption(USE_FSAL_PROXY "build PROXY FSAL shared library" ON)
goption(USE_FSAL_VFS "build VFS FSAL shared library" ON)
goption(USE_FSAL_LUSTRE "build LUSTRE FSAL shared library" ON)
goption(USE_FSAL_CEPH "build CEPH FSAL shared library" ON)
goption(USE_FSAL_GPFS "build GPFS FSAL" ON)
goption(USE_FSAL_XFS "build XFS support in VFS FSAL" ON)
goption(USE_FSAL_PANFS "build PanFS support in VFS FSAL" OFF)
goption(USE_FSAL_GLUSTER "build GLUSTER FSAL shared library" ON)
goption(USE_FSAL_NULL "build NULL FSAL shared library" ON)
goption(USE_FSAL_RGW "build RGW FSAL shared library" ON)
goption(USE_FSAL_MEM "build Memory FSAL shared library" ON)

# nTIRPC
option(USE_SYSTEM_NTIRPC "Use the system nTIRPC, rather than the submodule" OFF)
option (USE_GSS "enable RPCSEC_GSS support" ON)
option(TIRPC_EPOLL "platform supports EPOLL or emulation" ON)

# Build configure options
goption(USE_DBUS "enable DBUS protocol support" ON)

# Various DBUS enabled features
option(USE_CB_SIMULATOR "enable callback simulator thread" OFF)

goption(USE_NFSIDMAP "Use of libnfsidmap for name resolution" ON)
option(ENABLE_ERROR_INJECTION "enable error injection" OFF)
option(ENABLE_VFS_DEBUG_ACL "Enable debug ACL store for VFS" OFF)
option(ENABLE_RFC_ACL "Use all RFC ACL checks" OFF)
option(USE_TOOL_MULTILOCK "build multilock tool" OFF)

# Electric Fence (-lefence) link flag
goption(USE_EFENCE "link with efence memory debug library" OFF)

# These are -D_FOO options, why ???  should be flags??
option(_NO_TCP_REGISTER "disable registration of tcp services on portmapper" OFF)
option(RPCBIND "enable registration with rpcbind" ON)
option(DEBUG_SAL "enable debugging of SAL by keeping list of all locks, stateids, and state owners" OFF)
option(_VALGRIND_MEMCHECK "Initialize buffers passed to GPFS ioctl that valgrind doesn't understand" OFF)
option(ENABLE_LOCKTRACE "Enable lock trace" OFF)
goption(PROXY_HANDLE_MAPPING "enable NFSv3 handle mapping for PROXY FSAL" OFF)
option(DEBUG_MDCACHE "Add various asserts to mdcache" OFF)

# Debug symbols (-g) build flag
option(DEBUG_SYMS "include debug symbols to binaries (-g option)" OFF)

# Add coverage information to build tree
option(COVERAGE "add flag to generate coverage data at runtime" OFF)

option(ENFORCE_GCC "enforce gcc as a the C compiler used for the project" OFF)

# Define CPACK component (to deal with sub packages)
set(CPACK_COMPONENTS_ALL daemon fsal headers tools)
set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "NFS-Ganesha daemon")
if (USE_SYSTEM_NTIRPC)
  # Don't include libntirpc in the tarball
  set(CPACK_SOURCE_IGNORE_FILES "libntirpc")
else(USE_SYSTEM_NTIRPC)
  # Don't include libntirpc's spec file; this can confuse rpmbuild
  set(CPACK_SOURCE_IGNORE_FILES "libntirpc.spec$")
endif(USE_SYSTEM_NTIRPC)

# Include custom config and cpack module
include(${CMAKE_SOURCE_DIR}/cmake/cpack_config.cmake)
include(CPack)

# MSPAC support -lwbclient link flag
goption(_MSPAC_SUPPORT "enable mspac Winbind support" ON)

# CUnit
goption(USE_CUNIT "Use Cunit test framework" OFF)

# Blkin (Zipkin) Tracing
option(USE_BLKIN "Use Blkin/Zipkin trace framework" OFF)
option(BLKIN_PREFIX "Blkin installation prefix" "/opt/blkin")
if(USE_BLKIN)
  find_package(LTTng)
  if(LTTNG_FOUND)
  else(LTTNG_FOUND)
    message(WARNING "LTTng libraries not found. Disabling USE_BLKIN")
    set(USE_BLKIN OFF)
  endif(LTTNG_FOUND)
  if (NOT BLKIN_PREFIX)
    set(BLKIN_PREFIX "/opt/blkin")
  endif(NOT BLKIN_PREFIX)
  set(BLKIN_PREFIX ${BLKIN_PREFIX} CACHE PATH "Blkin path")
  find_library(BLKIN NAMES blkin PATHS "${BLKIN_PREFIX}/lib" REQUIRED)
  find_library(BLKIN_INIT NAMES blkin_init PATHS "${BLKIN_REFIX}/lib" REQUIRED)
  find_library(LTTNG NAMES lttng-ust REQUIRED)
  # build flags
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_BLKIN -I${BLKIN_PREFIX}/include")
  set(SYSTEM_LIBRARIES ${BLKIN} ${SYSTEM_LIBRARIES})
  set(SYSTEM_LIBRARIES ${LTTNG}  ${SYSTEM_LIBRARIES})

=== src/MainNFSD/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

########### next target ###############

SET(MainServices_STAT_SRCS
   nfs_admin_thread.c
   nfs_rpc_callback.c
   nfs_worker_thread.c
   nfs_rpc_dispatcher_thread.c
   nfs_rpc_tcp_socket_manager_thread.c
   nfs_init.c
   nfs_lib.c
   nfs_reaper_thread.c
   ../support/client_mgr.c
)

if(USE_9P)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_dispatcher.c)
endif(USE_9P)

if(USE_9P AND USE_9P_RDMA)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_rdma_dispatcher.c
    9p_rdma_callbacks.c)
endif(USE_9P AND USE_9P_RDMA)

if(USE_NFS_RDMA)
  add_definitions(-D_USE_NFS_RDMA)
endif(USE_NFS_RDMA)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c)
endif(USE_CB_SIMULATOR)

if(USE_UPCALL_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    fsal_upcall_simulator_thread.c
    )
endif(USE_UPCALL_SIMULATOR)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c
    )
endif(USE_CB_SIMULATOR)

add_library(MainServices STATIC ${MainServices_STAT_SRCS})
add_sanitizers(MainServices)

# FSAL core sources
# fsal_manager and fsal_destroyer are the only objects referenced by the
# core server all the rest are for the common support of fsal plugins.

set(fsal_CORE_SRCS
   ../FSAL/fsal_convert.c
   ../FSAL/commonlib.c
   ../FSAL/fsal_manager.c
   ../FSAL/access_check.c
   ../FSAL/fsal_config.c
   ../FSAL/default_methods.c
   ../FSAL/common_pnfs.c
   ../FSAL/fsal_destroyer.c
   ../FSAL/fsal_helper.c
   ../FSAL_UP/fsal_up_top.c
   ../FSAL_UP/fsal_up_async.c
)

if (USE_ACL_MAPPING)
  set(fsal_CORE_SRCS
      ${fsal_CORE_SRCS}
      ../FSAL/posix_acls.c
  )
endif(USE_ACL_MAPPING)

add_library(FsalCore STATIC ${fsal_CORE_SRCS})
add_sanitizers(FsalCore)

########### next target ###############

SET(ganesha.nfsd_SRCS
   nfs_main.c
)

add_executable(ganesha.nfsd
  ${ganesha.nfsd_SRCS}
  ${fsal_CORE_SRCS}
)
add_sanitizers(ganesha.nfsd)

target_link_libraries(ganesha.nfsd
  MainServices
  ${PROTOCOLS}
  ${GANESHA_CORE}
  config_parsing
  ${LIBTIRPC_LIBRARIES}
  ${SYSTEM_LIBRARIES}
  ${LTTNG_LIBRARIES}
)

install(TARGETS ganesha.nfsd COMPONENT daemon DESTINATION bin)


########### install files ###############

# We are still missing the install of docs and stuff

=== src/Protocols/CMakeLists.txt ===
add_subdirectory(NFS)
add_subdirectory(XDR)
if(USE_NLM)
	add_subdirectory(NLM)
endif(USE_NLM)
add_subdirectory(RQUOTA)

if(USE_9P)
  add_subdirectory(9P)
endif(USE_9P)


########### install files ###############

=== src/SAL/CMakeLists.txt ===
########### next target ###############

SET(sal_STAT_SRCS
   state_async.c
   state_lock.c
   state_share.c
   state_misc.c
   state_layout.c
   state_deleg.c
   nfs4_clientid.c
   nfs4_state.c
   nfs4_state_id.c
   nfs4_lease.c
   nfs4_recovery.c
   nfs41_session_id.c
   nfs4_owner.c
   recovery/recovery_fs.c
   recovery/recovery_fs_ng.c
)

if(USE_NLM)
  set(sal_STAT_SRCS
    ${sal_STAT_SRCS}
    nlm_owner.c
    nlm_state.c
    )
endif(USE_NLM)

if(USE_9P)
  set(sal_STAT_SRCS
    ${sal_STAT_SRCS}
    9p_owner.c
    )
endif(USE_9P)

if(USE_RADOS_RECOV)
  set(sal_STAT_SRCS
    ${sal_STAT_SRCS}
    recovery/recovery_rados_kv.c
    recovery/recovery_rados_ng.c
    recovery/recovery_rados_cluster.c
    )
endif(USE_RADOS_RECOV)

add_library(sal STATIC ${sal_STAT_SRCS})
add_sanitizers(sal)

if(USE_RADOS_RECOV)
  include_directories(${RADOS_INCLUDE_DIR})
  target_link_libraries(sal rados_grace ${RADOS_LIBRARIES})
endif(USE_RADOS_RECOV)

########### install files ###############

=== src/config_parsing/CMakeLists.txt ===
find_package(BISON)
find_package(FLEX)

add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

BISON_TARGET(
  ConfigParser
  ${CMAKE_CURRENT_SOURCE_DIR}/conf_yacc.y
  ${CMAKE_CURRENT_BINARY_DIR}/conf_yacc.c
  COMPILE_FLAGS "--defines -pganesha_yy"
)

FLEX_TARGET(
  ConfigScanner
  ${CMAKE_CURRENT_SOURCE_DIR}/conf_lex.l
  ${CMAKE_CURRENT_BINARY_DIR}/conf_lex.c
  COMPILE_FLAGS "-Pganeshun_yy -olex.yy.c"
)

ADD_FLEX_BISON_DEPENDENCY(ConfigScanner ConfigParser)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

########### next target ###############

SET(config_parsing_STAT_SRCS
   analyse.c
   config_parsing.c
   conf_url.c
   analyse.h
)

if(RADOS_URLS)
  set(config_parsing_STAT_SRCS
    ${config_parsing_STAT_SRCS}
    conf_url_rados.c
    )

  include_directories(${RADOS_INCLUDE_DIR})
endif(RADOS_URLS)

add_library(config_parsing STATIC
  ${config_parsing_STAT_SRCS}
  ${BISON_ConfigParser_OUTPUTS}
  ${FLEX_ConfigScanner_OUTPUTS}
)

if(RADOS_URLS)
  target_link_libraries(config_parsing ${RADOS_LIBRARIES})
endif(RADOS_URLS)

add_sanitizers(config_parsing)

########### next target ###############

SET(verif_syntax_SRCS
   verif_syntax.c
)

add_executable(verif_syntax EXCLUDE_FROM_ALL ${verif_syntax_SRCS})
add_sanitizers(verif_syntax)

target_link_libraries(verif_syntax config_parsing log ${CMAKE_THREAD_LIBS_INIT})

if(RADOS_URLS)
  target_link_libraries(config_parsing ${RADOS_LIBRARIES})
endif(RADOS_URLS)

########### next target ###############

SET(test_parsing_SRCS
   test_parse.c
)

add_executable(test_parsing EXCLUDE_FROM_ALL ${test_parsing_SRCS})
add_sanitizers(test_parsing)

target_link_libraries(test_parsing config_parsing log ${CMAKE_THREAD_LIBS_INIT})


########### install files ###############

=== src/gtest/CMakeLists.txt ===
# Set CMAKE_CXX_FLAGS, for gtest presently
set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -std=gnu++14 -Wnon-virtual-dtor -Wno-invalid-offsetof")

set(UNITTEST_LIBS ${GTEST_LIBRARIES} boost_program_options boost_system ${PTHREAD_LIBS})
set(UNITTEST_CXX_FLAGS "${CMAKE_CXX_FLAGS} -I${PROJECT_SOURCE_DIR}/gtest -I${GTEST_INCLUDE_DIR} -fno-strict-aliasing")

set(GANESHA_LIBRARIES
  rpcal
  log
  support
  hash
  config_parsing
  MainServices
  ${PROTOCOLS}
  ${GANESHA_CORE}
  # the following double mention of fsalpseudo and FsalCore
  # static libs is NOT a typo
  fsalpseudo
  FsalCore
  fsalpseudo
  FsalCore
  ${LIBTIRPC_LIBRARIES}
  ${SYSTEM_LIBRARIES}
  )

add_subdirectory(fsal_api)
add_subdirectory(nfs4)

# generic test
set(test_example_SRCS
  test_example.cc
)
add_executable(test_example EXCLUDE_FROM_ALL
  ${test_example_SRCS})
add_sanitizers(test_example)

target_link_libraries(test_example
  ${CMAKE_THREAD_LIBS_INIT}
  ${UNITTEST_LIBS}
  ${LTTNG_LIBRARIES}
  pthread
  )
set_target_properties(test_example PROPERTIES COMPILE_FLAGS
  "${UNITTEST_CXX_FLAGS}")

# Test using ganesha internals
set(test_ci_hash_dist1_SRCS
  test_ci_hash_dist1.cc
  )

add_executable(test_ci_hash_dist1
  ${test_ci_hash_dist1_SRCS})
add_sanitizers(test_ci_hash_dist1)

target_link_libraries(test_ci_hash_dist1
  ${GANESHA_LIBRARIES}
  ${UNITTEST_LIBS}
  ${LTTNG_LIBRARIES}
  ${LTTNG_CTL_LIBRARIES}
  ${GPERFTOOLS_LIBRARIES}
  )
set_target_properties(test_ci_hash_dist1 PROPERTIES COMPILE_FLAGS
  "${UNITTEST_CXX_FLAGS}")

set(test_rbt_SRCS
  test_rbt.cc
  )

add_executable(test_rbt
  ${test_rbt_SRCS})
add_sanitizers(test_rbt)

target_link_libraries(test_rbt
  ${GANESHA_LIBRARIES}
  ${UNITTEST_LIBS}
  ${LTTNG_LIBRARIES}
  ${LTTNG_CTL_LIBRARIES}
  ${GPERFTOOLS_LIBRARIES}
  )
set_target_properties(test_rbt PROPERTIES COMPILE_FLAGS
  "${UNITTEST_CXX_FLAGS}")

=== src/idmapper/CMakeLists.txt ===
if(_MSPAC_SUPPORT)
  include_directories(
    ${WBCLIENT_INCLUDE_DIR}
    )
endif(_MSPAC_SUPPORT)

########### next target ###############

SET(idmap_STAT_SRCS
   idmapper.c
   idmapper_cache.c
)

add_library(idmap STATIC ${idmap_STAT_SRCS})
add_sanitizers(idmap)

########### install files ###############

=== src/support/CMakeLists.txt ===
if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

# string utilities.  This should eventually go into src/os
# because BSD has them and Linux doesn't

set(string_utils_STAT_SRCS
   strlcpy.c
   strnlen.c
)

add_library(string_utils STATIC ${string_utils_STAT_SRCS})
add_sanitizers(string_utils)

# hash function libraries

set(hash_SRCS
   murmur3.c
   city.c
)

add_library(hash STATIC ${hash_SRCS})
add_sanitizers(hash)

# uid2grp mapper
set( uid2grp_SRCS
     uid2grp.c
     uid2grp_cache.c
)

add_library(uid2grp STATIC ${uid2grp_SRCS})
add_sanitizers(uid2grp)

# netgroup cache
set(netgroup_cache_SRCS
    netgroup_cache.c
)
add_library(netgroup_cache STATIC ${netgroup_cache_SRCS})
add_sanitizers(netgroup_cache)

if (USE_RADOS_RECOV)
   add_library(rados_grace STATIC rados_grace.c)
endif(USE_RADOS_RECOV)

########### next target ###############

SET(support_STAT_SRCS
   nfs4_acls.c
   nfs_creds.c
   nfs_filehandle_mgmt.c
   nfs_read_conf.c
   nfs_convert.c
   nfs_ip_name.c
   ds.c
   exports.c
   fridgethr.c
   delayed_exec.c
   misc.c
   bsd-base64.c
   server_stats.c
   export_mgr.c
   nfs4_fs_locations.c
)

if(ERROR_INJECTION)
  set(support_STAT_SRCS
    ${support_STAT_SRCS}
    err_inject.c
    )
endif(ERROR_INJECTION)

if(APPLE)
  set(support_STAT_SRCS
    ${support_STAT_SRCS}
    misc.c
    )
endif(APPLE)

add_library(support STATIC ${support_STAT_SRCS})
add_sanitizers(support)

########### install files ###############

=== src/test/CMakeLists.txt ===

if(USE_CUNIT)
  SET(test_avl_SRCS
    test_avl.c
    )
  add_executable(test_avl EXCLUDE_FROM_ALL ${test_avl_SRCS})
  target_link_libraries(test_avl ${CMAKE_THREAD_LIBS_INIT})

  SET(test_mh_avl_SRCS
    test_mh_avl.c
    ../support/murmur3.c
    )
  add_executable(test_mh_avl EXCLUDE_FROM_ALL ${test_mh_avl_SRCS})
  target_link_libraries(test_mh_avl ${CMAKE_THREAD_LIBS_INIT})
endif(USE_CUNIT)

SET(test_glist_SRCS
   test_glist.c
)
add_executable(test_glist EXCLUDE_FROM_ALL ${test_glist_SRCS})
target_link_libraries(test_glist ${CMAKE_THREAD_LIBS_INIT})

SET(test_url_regex_SRCS
  test_url_regex.c
  )
add_executable(test_url_regex EXCLUDE_FROM_ALL ${test_url_regex_SRCS})
target_link_libraries(test_url_regex ${CMAKE_THREAD_LIBS_INIT})

=== src/tools/CMakeLists.txt ===
if (USE_RADOS_RECOV)
  add_executable(ganesha-rados-grace ganesha-rados-grace.c)
  target_link_libraries(ganesha-rados-grace rados_grace ${RADOS_LIBRARIES})
  install(TARGETS ganesha-rados-grace COMPONENT tools DESTINATION bin)
endif(USE_RADOS_RECOV)

########### install files ###############

if(USE_TOOL_MULTILOCK)
  add_subdirectory(multilock)
endif(USE_TOOL_MULTILOCK)

=== src/FSAL/FSAL_GLUSTER/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
  ${GFAPI_CFLAGS}
)

set( LIB_PREFIX 64)

#add_subdirectory(pnfs_panfs)

#if(USE_FSAL_XFS)
#    add_subdirectory(xfs)
#endif(USE_FSAL_XFS)

########### next target ###############

SET(fsalgluster_LIB_SRCS
   main.c
   export.c
   handle.c
   fsal_up.c
   gluster_internal.h
   gluster_internal.c
   mds.c
   ds.c
)

add_library(fsalgluster MODULE ${fsalgluster_LIB_SRCS})
add_sanitizers(fsalgluster)

target_link_libraries(fsalgluster
  ${SYSTEM_LIBRARIES}
  ${GFAPI_LIBRARIES}
)

set_target_properties(fsalgluster PROPERTIES VERSION 4.2.0 SOVERSION 4)
install(TARGETS fsalgluster COMPONENT fsal DESTINATION ${FSAL_DESTINATION} )


########### install files ###############

=== src/FSAL/FSAL_PSEUDO/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

set( LIB_PREFIX 64)

########### next target ###############

SET(fsalpseudo_LIB_SRCS
   handle.c
   pseudofs_methods.h
   main.c
   export.c
)

add_library(fsalpseudo STATIC ${fsalpseudo_LIB_SRCS})
add_sanitizers(fsalpseudo)

########### install files ###############

=== debian/changelog ===
nfs-ganesha (2.7.1-2) unstable; urgency=medium

  * change watch file to use git directly on github to copy with to many
    versions on the 1st release page.
  * change builddepends from glusterfs-common to libglusterfs-dev (closes:
    919669)

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 18 Jan 2019 15:09:03 +0100

nfs-ganesha (2.7.1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

  [ Christoph Martin ]
  * New upstream version 2.7.1

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 30 Oct 2018 10:47:05 +0100

=== debian/control ===
Source: nfs-ganesha
Section: net
Priority: optional
Maintainer: Philippe Deniel <philippe.deniel@cea.fr>
Uploaders: Christoph Martin <martin@uni-mainz.de>
Standards-Version: 4.1.1
Homepage: https://github.com/nfs-ganesha/nfs-ganesha
Build-Depends: debhelper (>= 9),
               quilt,
               bison,
               flex,
               cmake,
               libdbus-1-dev,
               libnfsidmap-dev,
               libwbclient-dev,
               libntirpc-dev (>= 1.7.0),
               libkrb5-dev,
               libblkid-dev,
               libattr1-dev,
               libacl1-dev,
               lttng-tools,
               liblttng-ust-dev,
               liblttng-ctl-dev,
               liburcu-dev,
               xfslibs-dev,
               uuid-dev,
               libcap-dev,
               libglusterfs-dev (>= 3.13.0),
	       librgw-dev,
	       libcephfs-dev,
               python-dev,
               dh-python,
	       dh-systemd,
               python-qt4,
	       python-sphinx,
               pyqt4-dev-tools,
               pkgconf
Vcs-Git: https://salsa.debian.org/debian/nfs-ganesha.git
Vcs-Browser: https://salsa.debian.org/debian/nfs-ganesha

Package: nfs-ganesha
Multi-Arch: foreign
Architecture: any
Depends: dbus, nfs-common, rpcbind,
         ${perl:Depends},
         ${misc:Depends},
	 ${shlibs:Depends},
         daemon
Description: NFS server in User Space
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains the binaries

Package: nfs-ganesha-mount-9p
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version}),
Description: nfs-ganesha mount.9P
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains mount.9P

Package: nfs-ganesha-gluster
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version}),
         glusterfs-common (>= 3.10.0)
Description: nfs-ganesha fsal gluster libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for FSAL_GLUSTER and an example .conf file

Package: nfs-ganesha-ceph
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal ceph libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_CEPH and an example ceph.conf file

Package: nfs-ganesha-vfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal vfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_VFS and an example vfs.conf file

Package: nfs-ganesha-xfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal xfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_XFS and an example xfs.conf file

Package: nfs-ganesha-mem
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal mem libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_MEM and an example mem.conf file

Package: nfs-ganesha-nullfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal nullfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_NULLFS

Package: nfs-ganesha-proxy
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal proxy libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_PROXY

Package: nfs-ganesha-gpfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal gpfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_GPFS and conf files.

Package: python-nfs-ganesha
Pre-Depends: ${misc:Pre-Depends}
Architecture: all
Section: python
Provides: ${python:Provides}
Depends: python-dbus,
         python-qt4,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Description: Python bindings for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains Python bindings for nfs-ganesha admin

Package: nfs-ganesha-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
Description: Documentation for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains documentation and examples for nfs-ganesha

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Expected debian/rules file that is used by the dpkg build procedure
#
#   $ git clone <nfs-ganesha>
#   $ cd nfs-ganesha/src
#   $ dpkg-buildpackage -uc -us
#
export PREFIX=/usr
export DESTDIR=$(CURDIR)/debian/tmp
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	 dh $@ --with python2,systemd

override_dh_auto_configure:
	 cd src && ln -s ../debian .
	 cd src && dh_auto_configure -- \
		-DBUILD_CONFIG=debian \
		-DFSAL_DESTINATION=/usr/lib/${DEB_HOST_MULTIARCH}/ganesha \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_FSAL_NULL=YES \
		-DUSE_FSAL_ZFS=NO \
		-DUSE_FSAL_XFS=YES \
		-DUSE_FSAL_LUSTRE=NO \
		-DUSE_FSAL_CEPH=YES \
		-DUSE_FSAL_RGW=NO \
		-DUSE_FSAL_GPFS=YES \
		-DUSE_FSAL_PANFS=NO \
		-DUSE_FSAL_GLUSTER=YES \
		-DUSE_SYSTEM_NTIRPC=YES \
		-DUSE_9P_RDMA=NO \
		-DUSE_LTTNG=YES \
		-DUSE_ADMIN_TOOLS=YES \
		-DUSE_GUI_ADMIN_TOOLS=YES \
		-DUSE_RADOS_RECOV=NO \
		-DUSE_RADOS_URLS=NO \
		-DUSE_FSAL_VFS=ON \
		-DUSE_FSAL_PROXY=ON \
		-DUSE_DBUS=ON \
		-DUSE_9P=ON \
		-DDISTNAME_HAS_GIT_DATA=OFF \
		-DUSE_MAN_PAGE=YES

override_dh_auto_build:
	cd src && dh_auto_build

override_dh_auto_test:

override_dh_install:
	mkdir -p debian/tmp/etc/ganesha/
	mkdir -p debian/tmp/lib/systemd/system
	mkdir -p debian/tmp/etc/default
	mkdir -p debian/tmp/etc/logrotate.d/
	mkdir -p debian/tmp/etc/dbus-1/system.d/
	mkdir -p debian/tmp/usr/lib/ganesha/
	mkdir -p debian/tmp/usr/sbin/
	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/ganesha.conf
	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/vfs.conf
	cp src/config_samples/xfs.conf debian/tmp/etc/ganesha/xfs.conf
	cp src/config_samples/rgw.conf debian/tmp/etc/ganesha/rgw.conf
	cp src/config_samples/mem.conf debian/tmp/etc/ganesha/mem.conf
	cp src/config_samples/gluster.conf debian/tmp/etc/ganesha/gluster.conf
	cp src/config_samples/ceph.conf debian/tmp/etc/ganesha/ceph.conf
	cp src/config_samples/gpfs.conf debian/tmp/etc/ganesha/gpfs.conf
	cp src/config_samples/gpfs.ganesha.exports.conf debian/tmp/etc/ganesha/gpfs.ganesha.exports.conf
	cp src/config_samples/gpfs.ganesha.log.conf debian/tmp/etc/ganesha/gpfs.ganesha.log.conf
	cp src/config_samples/gpfs.ganesha.main.conf debian/tmp/etc/ganesha/gpfs.ganesha.main.conf
	cp src/config_samples/gpfs.ganesha.nfsd.conf debian/tmp/etc/ganesha/gpfs.ganesha.nfsd.conf
	cp src/config_samples/logrotate_ganesha debian/tmp/etc/logrotate.d/nfs-ganesha
	cp src/config_samples/logrotate_fsal_gluster debian/tmp/etc/logrotate.d/nfs-ganesha-gfapi
	cp src/scripts/systemd/nfs-ganesha.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha.service
	cp src/scripts/systemd/nfs-ganesha-config.service debian/tmp/lib/systemd/system/
	cp src/scripts/systemd/nfs-ganesha-lock.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha-lock.service
	cp src/scripts/systemd/sysconfig/nfs-ganesha debian/tmp/etc/default/
	cp src/scripts/ganeshactl/org.ganesha.nfsd.conf debian/tmp/etc/dbus-1/system.d/nfs-ganesha-dbus.conf
	install -m 755 src/scripts/nfs-ganesha-config.sh debian/tmp/usr/lib/ganesha/
	install -m 755 src/tools/mount.9P debian/tmp/usr/sbin/
	make -C src/obj-*-linux-gnu* install && dh_install --sourcedir=./src

## nfs-ganesha 2.7.3

=== debian/changelog ===
nfs-ganesha (2.7.3-2) buster; urgency=medium

  * nfs-ganesha 2.7.3 w/ nfs-ganesha-conf.sh

 -- Gluster Packager <glusterpackager@download.gluster.org>  Mon, 29 Apr 2019 15:30:00 -0400

nfs-ganesha (2.7.3-1) buster; urgency=medium

  * nfs-ganesha 2.7.3 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Tue, 9 Apr 2019 15:30:00 -0400

nfs-ganesha (2.7.2-1) buster; urgency=medium

  * nfs-ganesha 2.7.2 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Thu, 7 Mar 2019 15:30:00 -0400

nfs-ganesha (2.7.1-2) buster; urgency=medium

  * nfs-ganesha 2.7.1 with fsal-ceph and fsal-rgw

 -- Gluster Packager <glusterpackager@download.gluster.org>  Mon, 10 Dec 2018 15:30:00 -0400

nfs-ganesha (2.7.1-1) buster; urgency=medium

  * nfs-ganesha 2.7.1 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Mon, 26 Nov 2018 15:30:00 -0400

nfs-ganesha (2.7.0-2) buster; urgency=medium

  * nfs-ganesha 2.7.0 GA, logrotate.d/nfs-ganesha-gfapi

 -- Gluster Packager <glusterpackager@download.gluster.org>  Tue, 25 Sep 2018 15:30:00 -0400

nfs-ganesha (2.7.0-1) buster; urgency=medium

  * nfs-ganesha 2.7.0 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Wed, 19 Sep 2018 15:30:00 -0400

nfs-ganesha (2.6.3-1) buster; urgency=medium

  * nfs-ganesha 2.6.3 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Thu, 23 Aug 2018 15:30:00 -0400

nfs-ganesha (2.6.2-2) buster; urgency=medium

  * nfs-ganesha 2.6.2 /usr/lib/ganesha/nfs-ganesha-config.sh

 -- Gluster Packager <glusterpackager@download.gluster.org>  Tue, 29 May 2018 15:30:00 -0400

nfs-ganesha (2.6.2-1) buster; urgency=medium

  * nfs-ganesha 2.6.2 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Fri, 11 May 2018 15:30:00 -0400

nfs-ganesha (2.6.1-1) buster; urgency=medium

  * nfs-ganesha 2.6.1 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Thu, 22 Mar 2018 15:30:00 -0400

nfs-ganesha (2.6.0-1) buster; urgency=medium

  * nfs-ganesha 2.6.0 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Fri, 23 Feb 2018 15:30:00 -0400

nfs-ganesha (2.6.0-0.1rc3) buster; urgency=medium

  * nfs-ganesha 2.6 rc3

 -- Gluster Packager <glusterpackager@download.gluster.org>  Fri, 19 Jan 2018 15:30:00 -0400

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,17 @@
 Source: nfs-ganesha
 Section: net
 Priority: optional
-Maintainer: Philippe Deniel <philippe.deniel@cea.fr>
-Uploaders: Christoph Martin <martin@uni-mainz.de>
+Maintainer: Kaleb S. KEITHLEY <kkeithle@redhat.com>
 Standards-Version: 4.1.1
 Homepage: https://github.com/nfs-ganesha/nfs-ganesha
 Build-Depends: debhelper (>= 9),
-               quilt,
                bison,
                flex,
                cmake,
                libdbus-1-dev,
                libnfsidmap-dev,
                libwbclient-dev,
-               libntirpc-dev (>= 1.7.0),
+               libntirpc-dev (>= 1.7.3),
                libkrb5-dev,
                libblkid-dev,
                libattr1-dev,
@@ -25,34 +23,33 @@
                xfslibs-dev,
                uuid-dev,
                libcap-dev,
-               libglusterfs-dev (>= 3.13.0),
-	       librgw-dev,
-	       libcephfs-dev,
+               glusterfs-common (>= 4.1.0),
+               librgw-dev,
+               libcephfs-dev,
                python-dev,
                dh-python,
-	       dh-systemd,
+               dh-systemd,
                python-qt4,
-	       python-sphinx,
+               python-sphinx,
                pyqt4-dev-tools,
                pkgconf
-Vcs-Git: https://salsa.debian.org/debian/nfs-ganesha.git
-Vcs-Browser: https://salsa.debian.org/debian/nfs-ganesha
+Vcs-Git: https://github.com/nfs-ganesha/nfs-ganesha.git
 
 Package: nfs-ganesha
-Multi-Arch: foreign
 Architecture: any
 Depends: dbus, nfs-common, rpcbind,
+         ${shlibs:Depends},
          ${perl:Depends},
          ${misc:Depends},
-	 ${shlibs:Depends},
+         libwbclient0,
+         libntirpc1 (>= 1.7.2),
+         libtirpc3,
          daemon
-Description: NFS server in User Space
+Description: nfs-ganesha is a NFS server in User Space
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems
  and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
  HPSS, LUSTRE, XFS and ZFS.
- .
- This package contains the binaries
 
 Package: nfs-ganesha-mount-9p
 Multi-Arch: same
@@ -65,7 +62,6 @@
  It comes with various backend modules to support different file systems
  and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
  HPSS, LUSTRE, XFS and ZFS.
- .
  This package contains mount.9P
 
 Package: nfs-ganesha-gluster
@@ -107,19 +103,6 @@
  and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
  HPSS, LUSTRE, XFS and ZFS.
  This package contains a library for a FSAL_VFS and an example vfs.conf file
-
-Package: nfs-ganesha-xfs
-Multi-Arch: same
-Architecture: any
-Section: libs
-Depends: ${misc:Depends}, ${shlibs:Depends},
-         nfs-ganesha (=${binary:Version})
-Description: nfs-ganesha fsal xfs libraries
- NFS-GANESHA is a NFS Server running in user space with a large cache.
- It comes with various backend modules to support different file systems
- and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
- HPSS, LUSTRE, XFS and ZFS.
- This package contains a library for a FSAL_XFS and an example xfs.conf file
 
 Package: nfs-ganesha-mem
 Multi-Arch: same
@@ -173,6 +156,7 @@
  HPSS, LUSTRE, XFS and ZFS.
  This package contains a library for a FSAL_GPFS and conf files.
 
+
 Package: python-nfs-ganesha
 Pre-Depends: ${misc:Pre-Depends}
 Architecture: all
@@ -194,7 +178,6 @@
 Package: nfs-ganesha-doc
 Architecture: all
 Section: doc
-Depends: ${misc:Depends},
 Description: Documentation for nfs-ganesha
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems

=== debian/rules ===
--- 
+++ 
@@ -23,8 +23,7 @@
 		-DFSAL_DESTINATION=/usr/lib/${DEB_HOST_MULTIARCH}/ganesha \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		-DUSE_FSAL_NULL=YES \
-		-DUSE_FSAL_ZFS=NO \
-		-DUSE_FSAL_XFS=YES \
+		-DUSE_FSAL_XFS=NO \
 		-DUSE_FSAL_LUSTRE=NO \
 		-DUSE_FSAL_CEPH=YES \
 		-DUSE_FSAL_RGW=NO \
@@ -43,7 +42,9 @@
 		-DUSE_DBUS=ON \
 		-DUSE_9P=ON \
 		-DDISTNAME_HAS_GIT_DATA=OFF \
-		-DUSE_MAN_PAGE=YES
+		-DUSE_MAN_PAGE=YES \
+		-D_MSPAC_SUPPORT=YES \
+		-DSANITIZE_ADDRESS=NO
 
 override_dh_auto_build:
 	cd src && dh_auto_build
@@ -56,12 +57,13 @@
 	mkdir -p debian/tmp/etc/default
 	mkdir -p debian/tmp/etc/logrotate.d/
 	mkdir -p debian/tmp/etc/dbus-1/system.d/
+	mkdir -p debian/tmp/usr/lib/
 	mkdir -p debian/tmp/usr/lib/ganesha/
 	mkdir -p debian/tmp/usr/sbin/
 	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/ganesha.conf
 	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/vfs.conf
 	cp src/config_samples/xfs.conf debian/tmp/etc/ganesha/xfs.conf
-	cp src/config_samples/rgw.conf debian/tmp/etc/ganesha/rgw.conf
+	cp src/config_samples/ceph.conf debian/tmp/etc/ganesha/ceph.conf
 	cp src/config_samples/mem.conf debian/tmp/etc/ganesha/mem.conf
 	cp src/config_samples/gluster.conf debian/tmp/etc/ganesha/gluster.conf
 	cp src/config_samples/ceph.conf debian/tmp/etc/ganesha/ceph.conf
@@ -73,10 +75,11 @@
 	cp src/config_samples/logrotate_ganesha debian/tmp/etc/logrotate.d/nfs-ganesha
 	cp src/config_samples/logrotate_fsal_gluster debian/tmp/etc/logrotate.d/nfs-ganesha-gfapi
 	cp src/scripts/systemd/nfs-ganesha.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha.service
+	cp src/scripts/systemd/nfs-ganesha-lock.service.debian8 src/scripts/systemd/nfs-ganesha-lock.service
 	cp src/scripts/systemd/nfs-ganesha-config.service debian/tmp/lib/systemd/system/
 	cp src/scripts/systemd/nfs-ganesha-lock.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha-lock.service
 	cp src/scripts/systemd/sysconfig/nfs-ganesha debian/tmp/etc/default/
 	cp src/scripts/ganeshactl/org.ganesha.nfsd.conf debian/tmp/etc/dbus-1/system.d/nfs-ganesha-dbus.conf
-	install -m 755 src/scripts/nfs-ganesha-config.sh debian/tmp/usr/lib/ganesha/
-	install -m 755 src/tools/mount.9P debian/tmp/usr/sbin/
+	install -m 0755 src/scripts/nfs-ganesha-config.sh debian/tmp/usr/lib/ganesha/
+	install -m 0755 src/tools/mount.9P debian/tmp/usr/sbin/
 	make -C src/obj-*-linux-gnu* install && dh_install --sourcedir=./src
